/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.ResourceFileFormat;
import vip.xiaonuo.disk.mapper.ResourceFileFormatMapper;
import vip.xiaonuo.disk.param.ResourceFileFormatAddParam;
import vip.xiaonuo.disk.param.ResourceFileFormatEditParam;
import vip.xiaonuo.disk.param.ResourceFileFormatIdParam;
import vip.xiaonuo.disk.param.ResourceFileFormatPageParam;
import vip.xiaonuo.disk.service.ResourceFileFormatService;

import java.util.List;

/**
 * resource_file_formatService接口实现类
 *
 * @author pans
 * @date  2025/06/28 12:01
 **/
@Service
public class ResourceFileFormatServiceImpl extends ServiceImpl<ResourceFileFormatMapper, ResourceFileFormat> implements ResourceFileFormatService {


    @Override
    public Page<ResourceFileFormat> page(ResourceFileFormatPageParam resourceFileFormatPageParam) {
        QueryWrapper<ResourceFileFormat> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isNotEmpty(resourceFileFormatPageParam.getSearchKey())){
            queryWrapper.lambda().like(ResourceFileFormat::getFileExtendName, resourceFileFormatPageParam.getSearchKey());
        }
        if(ObjectUtil.isAllNotEmpty(resourceFileFormatPageParam.getSortField(), resourceFileFormatPageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(resourceFileFormatPageParam.getSortOrder());
            queryWrapper.orderBy(true, resourceFileFormatPageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(resourceFileFormatPageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(ResourceFileFormat::getId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ResourceFileFormatAddParam resourceFileFormatAddParam) {
        ResourceFileFormat resourceFileFormat = BeanUtil.toBean(resourceFileFormatAddParam, ResourceFileFormat.class);
        this.save(resourceFileFormat);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(ResourceFileFormatEditParam resourceFileFormatEditParam) {
        ResourceFileFormat resourceFileFormat = this.queryEntity(resourceFileFormatEditParam.getId());
        BeanUtil.copyProperties(resourceFileFormatEditParam, resourceFileFormat);
        this.updateById(resourceFileFormat);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<ResourceFileFormatIdParam> resourceFileFormatIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(resourceFileFormatIdParamList, ResourceFileFormatIdParam::getId));
    }

    @Override
    public ResourceFileFormat detail(ResourceFileFormatIdParam resourceFileFormatIdParam) {
        return this.queryEntity(resourceFileFormatIdParam.getId());
    }

    @Override
    public ResourceFileFormat queryEntity(Integer id) {
        ResourceFileFormat resourceFileFormat = this.getById(id);
        if(ObjectUtil.isEmpty(resourceFileFormat)) {
            throw new CommonException("resource_file_format不存在，id值为：{}", id);
        }
        return resourceFileFormat;
    }

}
